%%------------------------------------------------------------
%%
%% Standard implementation stubs.
%% 
%% This file has been generated from "/tmp/a/ports/lang/erlang/work/otp_src_R8B-1/lib/cosFileTransfer/src/CosFileTransfer.idl",
%% by using the IC compiler, version 4.1.2 .
%% 
%% DO NOT EDIT THIS FILE.
%%
%%------------------------------------------------------------

-module('CosFileTransfer_VirtualFileSystem').



%% Interface functions
-export(['_get_file_system_type'/1, '_get_supported_content_types'/1, login/4]).

%% Type identification function
-export([typeID/0]).

%% Used to start server
-export([oe_create/0, oe_create_link/0, oe_create/1]).
-export([oe_create_link/1, oe_create/2, oe_create_link/2]).

-export([start/1, start_link/1]).

%% gen server export stuff
-behaviour(gen_server).
-export([init/1, terminate/2, handle_call/3]).
-export([handle_cast/2, handle_info/2, code_change/3]).

-include_lib("orber/include/corba.hrl").


%%------------------------------------------------------------
%%
%% Object interface functions.
%%
%%------------------------------------------------------------



%%%% Operation: '_get_file_system_type'
%% 
%%   Returns: RetVal
%%
'_get_file_system_type'(OE_THIS) ->
    corba:call(OE_THIS, '_get_file_system_type', [], {{tk_enum,
                                                          "IDL:omg.org/CosFileTransfer/VirtualFileSystem/NativeFileSystemType:1.0",
                                                          "NativeFileSystemType",
                                                          ["FTAM",
                                                           "FTP",
                                                           "NATIVE"]},
                                                      [],
                                                      []}, infinity).

%%%% Operation: '_get_supported_content_types'
%% 
%%   Returns: RetVal
%%
'_get_supported_content_types'(OE_THIS) ->
    corba:call(OE_THIS, '_get_supported_content_types', [], {{tk_sequence,
                                                                 tk_long,
                                                                 0},
                                                             [],
                                                             []}, infinity).

%%%% Operation: login
%% 
%%   Returns: RetVal, Root
%%   Raises:  CosFileTransfer::SessionException, CosFileTransfer::FileNotFoundException, CosFileTransfer::IllegalOperationException
%%
login(OE_THIS, Username, Password, Account) ->
    corba:call(OE_THIS, login, [Username, Password, Account], {{tk_objref,
                                                                   "IDL:omg.org/CosFileTransfer/FileTransferSession:1.0",
                                                                   "FileTransferSession"},
                                                               [{tk_string,0},
                                                                {tk_string,0},
                                                                {tk_string,0}],
                                                               [{tk_objref,
                                                                    "IDL:omg.org/CosFileTransfer/Directory:1.0",
                                                                    "Directory"}]}, infinity).




%%------------------------------------------------------------
%%
%% Object server implementation.
%%
%%------------------------------------------------------------


%%------------------------------------------------------------
%%
%% Function for fetching the interface type ID.
%%
%%------------------------------------------------------------

typeID() ->
    "IDL:omg.org/CosFileTransfer/VirtualFileSystem:1.0".


%%------------------------------------------------------------
%%
%% Object creation functions.
%%
%%------------------------------------------------------------

oe_create() ->
    corba:create(?MODULE, "IDL:omg.org/CosFileTransfer/VirtualFileSystem:1.0").

oe_create_link() ->
    corba:create_link(?MODULE, "IDL:omg.org/CosFileTransfer/VirtualFileSystem:1.0").

oe_create(Env) ->
    corba:create(?MODULE, "IDL:omg.org/CosFileTransfer/VirtualFileSystem:1.0", Env).

oe_create_link(Env) ->
    corba:create_link(?MODULE, "IDL:omg.org/CosFileTransfer/VirtualFileSystem:1.0", Env).

oe_create(Env, RegName) ->
    corba:create(?MODULE, "IDL:omg.org/CosFileTransfer/VirtualFileSystem:1.0", Env, RegName).

oe_create_link(Env, RegName) ->
    corba:create_link(?MODULE, "IDL:omg.org/CosFileTransfer/VirtualFileSystem:1.0", Env, RegName).

%%------------------------------------------------------------
%%
%% Start functions.
%%
%%------------------------------------------------------------

start(Env) ->
    gen_server:start(?MODULE, Env, []).

start_link(Env) ->
    gen_server:start_link(?MODULE, Env, []).

%%------------------------------------------------------------
%%
%% Init & terminate functions.
%%
%%------------------------------------------------------------

init(Env) ->
%% Call to implementation init
    'CosFileTransfer_VirtualFileSystem_impl':init(Env).

terminate(Reason, State) ->
    catch ('CosFileTransfer_VirtualFileSystem_impl':terminate(Reason, State)).

%%------------------------------------------------------------
%%
%% Call & Cast macros.
%%
%%------------------------------------------------------------

-define(OE_CALL(Mod, Fun, Args),
        Result = case catch apply(Mod, Fun, Args) of
            {'EXIT', OE} -> exit(OE);
            OE_1 when element(1, OE_1)=='EXCEPTION' ->
                {reply, OE_1, OE_State};
            OE_2 when element(1, OE_2)=='reply' ->
                OE_2;
            OE_3 when element(1, OE_3)=='noreply' ->
                OE_3;
            OE_4 when element(1, OE_4)=='stop' ->
                OE_4;
            {OE_Reply, OE_NewState} -> {reply, OE_Reply, OE_NewState}
        end).
-define(OE_CAST(Mod, Fun, Args),
        Result = case catch apply(Mod, Fun, Args) of
            {'EXIT', OE} -> exit(OE);
            OE_1 when element(1, OE_1)=='EXCEPTION' ->
                {noreply, OE_State};
            OE_2 when element(1, OE_2)=='noreply' ->
                OE_2;
            OE_3 when element(1, OE_3)=='stop' ->
                OE_3;
            OE_NewState -> {noreply, OE_NewState}
        end).



%%%% Operation: '_get_file_system_type'
%% 
%%   Returns: RetVal
%%
handle_call({OE_THIS, '_get_file_system_type', []}, OE_From, OE_State) ->
  ?OE_CALL('CosFileTransfer_VirtualFileSystem_impl', '_get_file_system_type', [OE_THIS, OE_State]);

%%%% Operation: '_get_supported_content_types'
%% 
%%   Returns: RetVal
%%
handle_call({OE_THIS, '_get_supported_content_types', []}, OE_From, OE_State) ->
  ?OE_CALL('CosFileTransfer_VirtualFileSystem_impl', '_get_supported_content_types', [OE_THIS, OE_State]);

%%%% Operation: login
%% 
%%   Returns: RetVal, Root
%%   Raises:  CosFileTransfer::SessionException, CosFileTransfer::FileNotFoundException, CosFileTransfer::IllegalOperationException
%%
handle_call({OE_THIS, login, [Username, Password, Account]}, OE_From, OE_State) ->
  ?OE_CALL('CosFileTransfer_VirtualFileSystem_impl', login, [OE_THIS, OE_State, Username, Password, Account]);

%%%% Standard Operation: oe_get_interface
%%
handle_call({OE_THIS, oe_get_interface, []}, From, State) ->
    {reply, [{"_get_file_system_type",
              {{tk_enum,"IDL:omg.org/CosFileTransfer/VirtualFileSystem/NativeFileSystemType:1.0",
                        "NativeFileSystemType",
                        ["FTAM","FTP","NATIVE"]},
               [],
               []}},
             {"_get_supported_content_types",{{tk_sequence,tk_long,0},[],[]}},
             {"login",
              {{tk_objref,"IDL:omg.org/CosFileTransfer/FileTransferSession:1.0",
                          "FileTransferSession"},
               [{tk_string,0},{tk_string,0},{tk_string,0}],
               [{tk_objref,"IDL:omg.org/CosFileTransfer/Directory:1.0",
                           "Directory"}]}}], State};



%%%% Standard gen_server call handle
%%
handle_call(stop, From, State) ->
    {stop, normal, ok, State};

handle_call(Req, From, State) ->
    {reply, catch corba:raise(#'BAD_OPERATION'{completion_status='COMPLETED_NO'}), State}.


%%%% Standard gen_server cast handle
%%
handle_cast(stop, State) ->
    {stop, normal, State};

handle_cast(Req, State) ->
    {reply, catch corba:raise(#'BAD_OPERATION'{completion_status='COMPLETED_NO'}), State}.


%%%% Standard gen_server handles
%%
handle_info(Info, State) ->
    'CosFileTransfer_VirtualFileSystem_impl':handle_info(Info, State).


code_change(OldVsn, State, Extra) ->
    'CosFileTransfer_VirtualFileSystem_impl':code_change(OldVsn, State, Extra).

