%%------------------------------------------------------------
%%
%% Standard implementation stubs.
%% 
%% This file has been generated from "/tmp/a/ports/lang/erlang/work/otp_src_R8B-1/lib/cosProperty/src/CosProperty.idl",
%% by using the IC compiler, version 4.1.2 .
%% 
%% DO NOT EDIT THIS FILE.
%%
%%------------------------------------------------------------

-module('CosPropertyService_PropertySet').



%% Interface functions
-export([define_property/3, define_properties/2, get_number_of_properties/1]).
-export([get_all_property_names/2, get_property_value/2, get_properties/2]).
-export([get_all_properties/2, delete_property/2, delete_properties/2]).
-export([delete_all_properties/1, is_property_defined/2]).

%% Type identification function
-export([typeID/0]).

%% Used to start server
-export([oe_create/0, oe_create_link/0, oe_create/1]).
-export([oe_create_link/1, oe_create/2, oe_create_link/2]).

-export([start/1, start_link/1]).

%% gen server export stuff
-behaviour(gen_server).
-export([init/1, terminate/2, handle_call/3]).
-export([handle_cast/2, handle_info/2, code_change/3]).

-include_lib("orber/include/corba.hrl").


%%------------------------------------------------------------
%%
%% Object interface functions.
%%
%%------------------------------------------------------------



%%%% Operation: define_property
%% 
%%   Returns: RetVal
%%   Raises:  CosPropertyService::InvalidPropertyName, CosPropertyService::ConflictingProperty, CosPropertyService::UnsupportedTypeCode, CosPropertyService::UnsupportedProperty, CosPropertyService::ReadOnlyProperty
%%
define_property(OE_THIS, Property_name, Property_value) ->
    corba:call(OE_THIS, define_property, [Property_name, Property_value], {tk_void,
                                                                              [{tk_string,
                                                                                   0},
                                                                               tk_any],
                                                                              []}, infinity).

%%%% Operation: define_properties
%% 
%%   Returns: RetVal
%%   Raises:  CosPropertyService::MultipleExceptions
%%
define_properties(OE_THIS, Nproperties) ->
    corba:call(OE_THIS, define_properties, [Nproperties], {tk_void,
                                                              [{tk_sequence,
                                                                   {tk_struct,
                                                                       "IDL:omg.org/CosPropertyService/Property:1.0",
                                                                       "Property",
                                                                       [{"property_name",
                                                                         {tk_string,
                                                                             0}},
                                                                        {"property_value",
                                                                         tk_any}]},
                                                                   0}],
                                                              []}, infinity).

%%%% Operation: get_number_of_properties
%% 
%%   Returns: RetVal
%%
get_number_of_properties(OE_THIS) ->
    corba:call(OE_THIS, get_number_of_properties, [], {tk_ulong,[],[]}, infinity).

%%%% Operation: get_all_property_names
%% 
%%   Returns: RetVal, Property_names, Rest
%%
get_all_property_names(OE_THIS, How_many) ->
    corba:call(OE_THIS, get_all_property_names, [How_many], {tk_void,
                                                                [tk_ulong],
                                                                [{tk_sequence,
                                                                     {tk_string,
                                                                         0},
                                                                     0},
                                                                 {tk_objref,
                                                                     "IDL:omg.org/CosPropertyService/PropertyNamesIterator:1.0",
                                                                     "PropertyNamesIterator"}]}, infinity).

%%%% Operation: get_property_value
%% 
%%   Returns: RetVal
%%   Raises:  CosPropertyService::PropertyNotFound, CosPropertyService::InvalidPropertyName
%%
get_property_value(OE_THIS, Property_name) ->
    corba:call(OE_THIS, get_property_value, [Property_name], {tk_any,
                                                                 [{tk_string,
                                                                      0}],
                                                                 []}, infinity).

%%%% Operation: get_properties
%% 
%%   Returns: RetVal, Nproperties
%%
get_properties(OE_THIS, Property_names) ->
    corba:call(OE_THIS, get_properties, [Property_names], {tk_boolean,
                                                              [{tk_sequence,
                                                                   {tk_string,
                                                                       0},
                                                                   0}],
                                                              [{tk_sequence,
                                                                   {tk_struct,
                                                                       "IDL:omg.org/CosPropertyService/Property:1.0",
                                                                       "Property",
                                                                       [{"property_name",
                                                                         {tk_string,
                                                                             0}},
                                                                        {"property_value",
                                                                         tk_any}]},
                                                                   0}]}, infinity).

%%%% Operation: get_all_properties
%% 
%%   Returns: RetVal, Nproperties, Rest
%%
get_all_properties(OE_THIS, How_many) ->
    corba:call(OE_THIS, get_all_properties, [How_many], {tk_void,
                                                            [tk_ulong],
                                                            [{tk_sequence,
                                                                 {tk_struct,
                                                                     "IDL:omg.org/CosPropertyService/Property:1.0",
                                                                     "Property",
                                                                     [{"property_name",
                                                                       {tk_string,
                                                                           0}},
                                                                      {"property_value",
                                                                       tk_any}]},
                                                                 0},
                                                             {tk_objref,
                                                                 "IDL:omg.org/CosPropertyService/PropertiesIterator:1.0",
                                                                 "PropertiesIterator"}]}, infinity).

%%%% Operation: delete_property
%% 
%%   Returns: RetVal
%%   Raises:  CosPropertyService::PropertyNotFound, CosPropertyService::InvalidPropertyName, CosPropertyService::FixedProperty
%%
delete_property(OE_THIS, Property_name) ->
    corba:call(OE_THIS, delete_property, [Property_name], {tk_void,
                                                              [{tk_string,0}],
                                                              []}, infinity).

%%%% Operation: delete_properties
%% 
%%   Returns: RetVal
%%   Raises:  CosPropertyService::MultipleExceptions
%%
delete_properties(OE_THIS, Property_names) ->
    corba:call(OE_THIS, delete_properties, [Property_names], {tk_void,
                                                                 [{tk_sequence,
                                                                      {tk_string,
                                                                          0},
                                                                      0}],
                                                                 []}, infinity).

%%%% Operation: delete_all_properties
%% 
%%   Returns: RetVal
%%
delete_all_properties(OE_THIS) ->
    corba:call(OE_THIS, delete_all_properties, [], {tk_boolean,[],[]}, infinity).

%%%% Operation: is_property_defined
%% 
%%   Returns: RetVal
%%   Raises:  CosPropertyService::InvalidPropertyName
%%
is_property_defined(OE_THIS, Property_name) ->
    corba:call(OE_THIS, is_property_defined, [Property_name], {tk_boolean,
                                                                  [{tk_string,
                                                                       0}],
                                                                  []}, infinity).




%%------------------------------------------------------------
%%
%% Object server implementation.
%%
%%------------------------------------------------------------


%%------------------------------------------------------------
%%
%% Function for fetching the interface type ID.
%%
%%------------------------------------------------------------

typeID() ->
    "IDL:omg.org/CosPropertyService/PropertySet:1.0".


%%------------------------------------------------------------
%%
%% Object creation functions.
%%
%%------------------------------------------------------------

oe_create() ->
    corba:create(?MODULE, "IDL:omg.org/CosPropertyService/PropertySet:1.0").

oe_create_link() ->
    corba:create_link(?MODULE, "IDL:omg.org/CosPropertyService/PropertySet:1.0").

oe_create(Env) ->
    corba:create(?MODULE, "IDL:omg.org/CosPropertyService/PropertySet:1.0", Env).

oe_create_link(Env) ->
    corba:create_link(?MODULE, "IDL:omg.org/CosPropertyService/PropertySet:1.0", Env).

oe_create(Env, RegName) ->
    corba:create(?MODULE, "IDL:omg.org/CosPropertyService/PropertySet:1.0", Env, RegName).

oe_create_link(Env, RegName) ->
    corba:create_link(?MODULE, "IDL:omg.org/CosPropertyService/PropertySet:1.0", Env, RegName).

%%------------------------------------------------------------
%%
%% Start functions.
%%
%%------------------------------------------------------------

start(Env) ->
    gen_server:start(?MODULE, Env, []).

start_link(Env) ->
    gen_server:start_link(?MODULE, Env, []).

%%------------------------------------------------------------
%%
%% Init & terminate functions.
%%
%%------------------------------------------------------------

init(Env) ->
%% Call to implementation init
    'CosPropertyService_PropertySet_impl':init(Env).

terminate(Reason, State) ->
    catch ('CosPropertyService_PropertySet_impl':terminate(Reason, State)).

%%------------------------------------------------------------
%%
%% Call & Cast macros.
%%
%%------------------------------------------------------------

-define(OE_CALL(Mod, Fun, Args),
        Result = case catch apply(Mod, Fun, Args) of
            {'EXIT', OE} -> exit(OE);
            OE_1 when element(1, OE_1)=='EXCEPTION' ->
                {reply, OE_1, OE_State};
            OE_2 when element(1, OE_2)=='reply' ->
                OE_2;
            OE_3 when element(1, OE_3)=='noreply' ->
                OE_3;
            OE_4 when element(1, OE_4)=='stop' ->
                OE_4;
            {OE_Reply, OE_NewState} -> {reply, OE_Reply, OE_NewState}
        end).
-define(OE_CAST(Mod, Fun, Args),
        Result = case catch apply(Mod, Fun, Args) of
            {'EXIT', OE} -> exit(OE);
            OE_1 when element(1, OE_1)=='EXCEPTION' ->
                {noreply, OE_State};
            OE_2 when element(1, OE_2)=='noreply' ->
                OE_2;
            OE_3 when element(1, OE_3)=='stop' ->
                OE_3;
            OE_NewState -> {noreply, OE_NewState}
        end).



%%%% Operation: define_property
%% 
%%   Returns: RetVal
%%   Raises:  CosPropertyService::InvalidPropertyName, CosPropertyService::ConflictingProperty, CosPropertyService::UnsupportedTypeCode, CosPropertyService::UnsupportedProperty, CosPropertyService::ReadOnlyProperty
%%
handle_call({OE_THIS, define_property, [Property_name, Property_value]}, OE_From, OE_State) ->
  ?OE_CALL('CosPropertyService_PropertySet_impl', define_property, [OE_THIS, OE_State, Property_name, Property_value]);

%%%% Operation: define_properties
%% 
%%   Returns: RetVal
%%   Raises:  CosPropertyService::MultipleExceptions
%%
handle_call({OE_THIS, define_properties, [Nproperties]}, OE_From, OE_State) ->
  ?OE_CALL('CosPropertyService_PropertySet_impl', define_properties, [OE_THIS, OE_State, Nproperties]);

%%%% Operation: get_number_of_properties
%% 
%%   Returns: RetVal
%%
handle_call({OE_THIS, get_number_of_properties, []}, OE_From, OE_State) ->
  ?OE_CALL('CosPropertyService_PropertySet_impl', get_number_of_properties, [OE_THIS, OE_State]);

%%%% Operation: get_all_property_names
%% 
%%   Returns: RetVal, Property_names, Rest
%%
handle_call({OE_THIS, get_all_property_names, [How_many]}, OE_From, OE_State) ->
  ?OE_CALL('CosPropertyService_PropertySet_impl', get_all_property_names, [OE_THIS, OE_State, How_many]);

%%%% Operation: get_property_value
%% 
%%   Returns: RetVal
%%   Raises:  CosPropertyService::PropertyNotFound, CosPropertyService::InvalidPropertyName
%%
handle_call({OE_THIS, get_property_value, [Property_name]}, OE_From, OE_State) ->
  ?OE_CALL('CosPropertyService_PropertySet_impl', get_property_value, [OE_THIS, OE_State, Property_name]);

%%%% Operation: get_properties
%% 
%%   Returns: RetVal, Nproperties
%%
handle_call({OE_THIS, get_properties, [Property_names]}, OE_From, OE_State) ->
  ?OE_CALL('CosPropertyService_PropertySet_impl', get_properties, [OE_THIS, OE_State, Property_names]);

%%%% Operation: get_all_properties
%% 
%%   Returns: RetVal, Nproperties, Rest
%%
handle_call({OE_THIS, get_all_properties, [How_many]}, OE_From, OE_State) ->
  ?OE_CALL('CosPropertyService_PropertySet_impl', get_all_properties, [OE_THIS, OE_State, How_many]);

%%%% Operation: delete_property
%% 
%%   Returns: RetVal
%%   Raises:  CosPropertyService::PropertyNotFound, CosPropertyService::InvalidPropertyName, CosPropertyService::FixedProperty
%%
handle_call({OE_THIS, delete_property, [Property_name]}, OE_From, OE_State) ->
  ?OE_CALL('CosPropertyService_PropertySet_impl', delete_property, [OE_THIS, OE_State, Property_name]);

%%%% Operation: delete_properties
%% 
%%   Returns: RetVal
%%   Raises:  CosPropertyService::MultipleExceptions
%%
handle_call({OE_THIS, delete_properties, [Property_names]}, OE_From, OE_State) ->
  ?OE_CALL('CosPropertyService_PropertySet_impl', delete_properties, [OE_THIS, OE_State, Property_names]);

%%%% Operation: delete_all_properties
%% 
%%   Returns: RetVal
%%
handle_call({OE_THIS, delete_all_properties, []}, OE_From, OE_State) ->
  ?OE_CALL('CosPropertyService_PropertySet_impl', delete_all_properties, [OE_THIS, OE_State]);

%%%% Operation: is_property_defined
%% 
%%   Returns: RetVal
%%   Raises:  CosPropertyService::InvalidPropertyName
%%
handle_call({OE_THIS, is_property_defined, [Property_name]}, OE_From, OE_State) ->
  ?OE_CALL('CosPropertyService_PropertySet_impl', is_property_defined, [OE_THIS, OE_State, Property_name]);

%%%% Standard Operation: oe_get_interface
%%
handle_call({OE_THIS, oe_get_interface, []}, From, State) ->
    {reply, [{"define_property",{tk_void,[{tk_string,0},tk_any],[]}},
             {"define_properties",
              {tk_void,[{tk_sequence,{tk_struct,
                                         "IDL:omg.org/CosPropertyService/Property:1.0",
                                         "Property",
                                         [{"property_name",{tk_string,0}},
                                          {"property_value",tk_any}]},
                                     0}],
                       []}},
             {"get_number_of_properties",{tk_ulong,[],[]}},
             {"get_all_property_names",
              {tk_void,[tk_ulong],
                       [{tk_sequence,{tk_string,0},0},
                        {tk_objref,"IDL:omg.org/CosPropertyService/PropertyNamesIterator:1.0",
                                   "PropertyNamesIterator"}]}},
             {"get_property_value",{tk_any,[{tk_string,0}],[]}},
             {"get_properties",
              {tk_boolean,[{tk_sequence,{tk_string,0},0}],
                          [{tk_sequence,
                               {tk_struct,
                                   "IDL:omg.org/CosPropertyService/Property:1.0",
                                   "Property",
                                   [{"property_name",{tk_string,0}},
                                    {"property_value",tk_any}]},
                               0}]}},
             {"get_all_properties",
              {tk_void,[tk_ulong],
                       [{tk_sequence,{tk_struct,
                                         "IDL:omg.org/CosPropertyService/Property:1.0",
                                         "Property",
                                         [{"property_name",{tk_string,0}},
                                          {"property_value",tk_any}]},
                                     0},
                        {tk_objref,"IDL:omg.org/CosPropertyService/PropertiesIterator:1.0",
                                   "PropertiesIterator"}]}},
             {"delete_property",{tk_void,[{tk_string,0}],[]}},
             {"delete_properties",
              {tk_void,[{tk_sequence,{tk_string,0},0}],[]}},
             {"delete_all_properties",{tk_boolean,[],[]}},
             {"is_property_defined",{tk_boolean,[{tk_string,0}],[]}}], State};



%%%% Standard gen_server call handle
%%
handle_call(stop, From, State) ->
    {stop, normal, ok, State};

handle_call(Req, From, State) ->
    {reply, catch corba:raise(#'BAD_OPERATION'{completion_status='COMPLETED_NO'}), State}.


%%%% Standard gen_server cast handle
%%
handle_cast(stop, State) ->
    {stop, normal, State};

handle_cast(Req, State) ->
    {reply, catch corba:raise(#'BAD_OPERATION'{completion_status='COMPLETED_NO'}), State}.


%%%% Standard gen_server handles
%%
handle_info(Info, State) ->
    {reply, catch corba:raise(#'BAD_OPERATION'{completion_status='COMPLETED_NO'}), State}.


code_change(OldVsn, State, Extra) ->
    'CosPropertyService_PropertySet_impl':code_change(OldVsn, State, Extra).

